# Tiny Tiny eDelphi --- EDpLight
# 	Copyright (c) 2002 Kazuhiro Yoshida 
#       You can redistribute it and/or modify it under the same term as Ruby.

require 'edp/compile'

class EDpLight

  def initialize(str, safe_level=nil, trim_mode=nil, eoutvar='S')
    @safe_level = safe_level
    compiler = EDpCompiler.new
    compiler.trim_mode = trim_mode
    set_eoutvar(compiler, eoutvar)
    @src = compiler.compile(str)
  end
  attr :src

  def set_eoutvar(compiler, eoutvar = 'S')
    compiler.put_cmd = "#{eoutvar}:=#{eoutvar}+"
    compiler.pre_cmd = <<EOT.split(/\n/)
procedure Tmod1.mod1fooAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
  #{eoutvar}: string;
begin
EOT
    compiler.post_cmd = <<EOT.split(/\n/)
  Response.Content := #{eoutvar};
end;
EOT
  end

  def run(b=TOPLEVEL_BINDING)
    print self.src
  end

end

if __FILE__ == $0
  require 'edp/main'

  EDpModule.run(EDpLight)
end
